<?php
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2008 ZoneO-soft, Butchu (email: "butchu" with the domain "zoneo.net")

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

// Langugage strings
$strings['TestSuccessful'] = "Test was succesful";
$strings['CanUseUpdate'] = "Test was succesful. Your system can use the update service.";
$strings['TestMoveFiles'] = "Testing moving files";
$strings['Testing'] = "Testing";
$strings['Testdwldupdate'] = "Test download update";
$strings['testfailed'] = "test failed";
$strings['testinfoupdate'] = "Testing information on the update";
$strings['IfUpdateTest'] = "If the update test was successful";
$strings['TestUpdateService'] = "Before registering, you should test your system and make sure that the update service works for you";
$strings['StartUpdateTest'] = "Click here to start the test of the update service";
$strings['Password'] = "Password";
$strings['RepeatPassword'] = "Repeat password";
$strings['UserID'] = "User ID";
$strings['Didregister'] = "If you registered or updated your information on the phpTrafficA website, enter your new information here.";
$strings['Update'] = "Update";
$strings['downloadfailed'] = "Download failed. ";
$strings['checkregistration'] = "Check that your registration is still valid at phpTrafficA.com. Also set your your registration ID, password, and expiration data in phpTrafficA here: ";
$strings['WhyRegister'] = "Registered phpTrafficA users can get update for sensitive information such as IP to country database, list of operating systems, list of web browsers, search engines, and IP block for known spammers.";
$strings['WhyRegister2'] = "Updates will be available at least 6 times per year. A message will appear under the site list in the main phpTrafficA window when you are loggued in. You will have to follow the link and decide what information you want to update. The rest will be fully automatic.";
$strings['regRemaining'] = "Days remaining for your registration";
$strings['donewithupdate'] = "Done with update";
$strings['updateversionwas'] = "Update version was";
$strings['insertIPRange'] = "Inserting new IP range";
$strings['doDelTmpUpdate'] = "Deleting temporary update files";
$strings['doInsertIPban'] = "Inserting ban IP for known spammers";
$strings['doUpgradeSEList'] = "Updating list of search engines";
$strings['doUpgradeOSList'] = "Updating list of operating systems";
$strings['doUpgradeWBList'] = "Updating list of web browsers";
$strings['doUpgradeIP2C'] = "Updating IP to country database";
$strings['DelTmpUpdate'] = "Delete temporary update files";
$strings['InsertIPban'] = "Insert ban IP for known spammers";
$strings['UpgradeSEList'] = "Update list of search engines";
$strings['UpgradeOSList'] = "Update list of operating systems";
$strings['UpgradeWBList'] = "Update list of web browsers";
$strings['UpgradeIP2C'] = "Update IP to country database";
$strings['missing'] = "not defined";
$strings['testOtherfiles'] = "Test other files";
$strings['testIP2Cfiles'] = "Testing files for IP to country database";
$strings['updatecheck'] = "Checking downloaded file";
$strings['Updatesavedin'] = "Update saved in";
$strings['dwldupdate'] = "Download update";
$strings['ip2cInUpdate'] = "Number of IP to country files in update";
$strings['otherInUpdate'] = "Other things in update";
$strings['updatereleasedate'] = "Update release date";
$strings['updateversion'] = "Update version";
$strings['infoupdate'] = "Information on the update";
$strings['updateservice'] = "update service";
$strings['UpdateAvailable'] = "Update is available for IP to country, OS, web browser, and IP ban lists.";
$strings['InstallUpdate'] = "Install the update now.";
$strings['Unregistered'] = "This version is not registered.";
$strings['Registered'] = "This version is registered.";


include("Php/Functions/archive.php");

/*********************************************************************************
/* Function: testService
/* Role: tries a download of a fake update a reading files within the update
/* Parameters:
/*   - $c: connection to the database
/* Output:
/* Created 04/2008 /********************************************************************************/
function testService($c) {
global $strings;

$phpTrafficAServer = "data.phptraffica.com";
$test = true;

// General info on update
echo "<div id=\"text\">\n<P><b>".$strings['testinfoupdate']."</b>";
$infoupdate = file("http://$phpTrafficAServer/test.def");
echo "<br>- ".$strings['updatereleasedate']." : ".$infoupdate[1];
if (strtotime($infoupdate[1]) != strtotime("2008-04-05 12:00")) {
	echo " - <span class=\"error\">".$strings['failed']."</span>";
	$test = false;
} else {
	echo " - <span class=\"ok\">".$strings['pass']."</span>";
}
$iptocFiles = explode("|", $infoupdate[2]);
echo "<br>- ".$strings['ip2cInUpdate']." : ".count($iptocFiles);
if (count($iptocFiles) != 4) {
	echo " - <span class=\"error\">".$strings['failed']."</span>";
	$test = false;
} else {
	echo " - <span class=\"ok\">".$strings['pass']."</span>";
}
$otherthings = explode("|", $infoupdate[3]);
echo "<br>- ".$strings['otherInUpdate']." : ".count($otherthings);
if (count($otherthings) != 4) {
	echo " - <span class=\"error\">".$strings['failed']."</span>";
	$test = false;
} else {
	echo " - <span class=\"ok\">".$strings['pass']."</span>";
}
if (!$test) {
	echo "<br><span class=\"error\">".$strings['testfailed']."</span></div>";
	return;
}

// Downloading update file
echo "</P>\n<P><b>".$strings['Testdwldupdate']."</b>";
$data = file("http://test:abc@${phpTrafficAServer}/get.php?test");
if (trim($data) == "") {
	echo "<p><span class=\"error\">".$strings['downloadfailed']."</span></p></div>";
	return;
}
$filename = './tmp/update.tgz';
$handle = fopen($filename, 'w');
for ($i=0; $i<count($data); $i++) {
	fwrite($handle, $data[$i]);
}
fclose($handle);
echo "<br>- ".$strings['Done'];
echo "<br>- ".$strings['Updatesavedin']." : ./tmp/update.tgz";

// Unpacking and checking update content
echo "</P>\n<P><b>".$strings['updatecheck']."</b>";
if (!is_dir("./Dwld")) mkdir("./Dwld");
$test = new gzip_file("./tmp/update.tgz");
$test->set_options(array('inmemory' => 0, 'overwrite' => 1));
$test->extract_files();
if(count($test->errors) != 0) print_r($test->errors);
$test = true;

// Testing ip2c files
echo "<br>- ".$strings['testIP2Cfiles']." :";
$testData = array("en|1|2", "er|3|4", "fr|5|6", "tr|7|8");
foreach ($iptocFiles as $index => $file) {
	$file = trim($file);
	$iptocFiles['index'] = $file;
	if ((!is_file($file) || (!is_readable($file)))) {
		if(is_file($file)) { $tt1 = 1; } else { $tt1 = 0;}
		if(is_readable($file)) { $tt2 = 1; } else { $tt2 = 0;}
		echo $file." ".$strings['missing']." ($tt1, $tt2), ";
		$test = false;
	}
}
if (!$test) {
	echo "<span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
for ($i=2; $i<6; $i++) {
	echo "<br>&nbsp;&nbsp;* ".$strings['Testing']." Dwld/$i.dat";
	$data = file("Dwld/$i.dat");
	for ($j=0;$j<($i-1);$j++) {
		if (!$data[$j] != $dataTest[$j]) {
			echo "<span class=\"error\">".$strings['failed']."</span>:  ".$dataTest[$j]."</div>";
			$test = false;
		}
	}
}
if (!$test) {
	echo "<br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>";

// Other things: ipbanlist, os_list...
echo "<br>- ".$strings['testOtherfiles']." : ";
include("./Dwld/dataSQL.php");
$test = true;
foreach ($otherthings as $index=>$what) {
	$what = trim($what);
	if (!isset($$what)) {
		echo "<br>&nbsp;&nbsp;* <span class=\"error\">$what ".$strings['missing']." </span>";
		$test = false;
	}
}
if (!($os_list == "List number one")) {
	echo "<br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span>: os_list</div>";
	$test = false;
} else {
	echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>: os_list</span>";
}
if (!($browser_list == "List number two")) {
	echo "<br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span>: browser_list</span>";
	$test = false;
} else {
	echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>: browser_list</span>";
}
if (!($search_engines == "List number three")) {
	echo "<br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span>: search_engines</span>";
	$test = false;
} else {
	echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>: search_engines</span>";
}
if (!($ipbanlist == "List number four")) {
	echo "<br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span>: ipbanlist</span>";
	$test = false;
} else {
	echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>: ipbanlist</span>";
}
if (!$test) {
	echo "<br>&nbsp;&nbsp;* <br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>";

// Testing move file
echo "\n<P><b>".$strings['TestMoveFiles']."</b>\n";
for ($i=2; $i<6; $i++) {
	echo "<br>&nbsp;&nbsp;* ".$strings['Testing']." Dwld/$i.dat - Ip2c/test$i.dat";
	if (!rename("Dwld/$i.dat", "Ip2c/test$i.dat")) {
		echo " <span class=\"error\">".$strings['failed']."</span>";
		$test = false;
	} else {
		echo " <span class=\"ok\">".$strings['pass']."</span>";
	}
}
if (!$test) {
	echo "<br>&nbsp;&nbsp;* <br>&nbsp;&nbsp;* <span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
echo "<br>&nbsp;&nbsp;* <span class=\"ok\">".$strings['pass']."</span>";
for ($i=2; $i<6; $i++) {
	unlink("Ip2c/test$i.dat");
}

echo "\n<P><b>".$strings['TestSuccessful']."</b></P>\n";
echo "\n<P>".$strings['CanUseUpdate']." <a href=\"http://www.phpTrafficA.com/register.php\">Register today!</a></P>\n";
echo "\n</div>\n";
}


/*********************************************************************************
/* Function: testUpdate
/* Role: download and test an update and display a form to actually install it
/* Parameters:
/*   - $c: connection to the database
/*   - $version: update version
/* Output:
/* Created 04/2008 /********************************************************************************/
function testUpdate($c,$version) {
global $strings;

$version = intval($version);
$phpTrafficAServer = "data.phptraffica.com";
$login = $registration['loginupdate'];
$password = $registration['passwordupdate'];

// General info on update
echo "<div id=\"text\">\n<P><b>".$strings['infoupdate']."</b>";
echo "<br>- ".$strings['updateversion']." : $version";
$infoupdate = file("http://$phpTrafficAServer/$version.def");
echo "<br>- ".$strings['updatereleasedate']." : ".$infoupdate[1];
$iptocFiles = explode("|", $infoupdate[2]);
echo "<br>- ".$strings['ip2cInUpdate']." : ".count($iptocFiles);
$otherthings = explode("|", $infoupdate[3]);
echo "<br>- ".$strings['otherInUpdate']." : ".count($otherthings);
// Downloading update file
echo "</P>\n<P><b>".$strings['dwldupdate']."</b>";
$data = file("http://${login}:${password}@${phpTrafficAServer}/get.php?${version}");
if (trim($data) == "") {
	echo "<p><span class=\"error\">".$strings['downloadfailed']."</class></p><p>".$strings['checkregistration']."</p></div>";
	return;
}
$filename = './tmp/update.tgz';
$handle = fopen($filename, 'w');
for ($i=0; $i<count($data); $i++) {
	fwrite($handle, $data[$i]);
}
fclose($handle);
echo "<br>- ".$strings['Done'];
echo "<br>- ".$strings['Updatesavedin']." : ./tmp/update.tgz";
// Unpacking and checking update content
echo "</P>\n<P><b>".$strings['updatecheck']."</b>";
if (!is_dir("./Dwld")) mkdir("./Dwld");
$test = new gzip_file("./tmp/update.tgz");
$test->set_options(array('inmemory' => 0, 'overwrite' => 1));
$test->extract_files();
if(count($test->errors) != 0) print_r($test->errors);
$test = true;
echo "<br>- ".$strings['testIP2Cfiles']." :";
foreach ($iptocFiles as $index => $file) {
	$file = trim($file);
	$iptocFiles['index'] = $file;
	if ((!is_file($file) || (!is_readable($file)))) {
		if(is_file($file)) { $tt1 = 1; } else { $tt1 = 0;}
		if(is_readable($file)) { $tt2 = 1; } else { $tt2 = 0;}
		echo $file." ".$strings['missing']." ($tt1, $tt2), ";
		$test = false;
	}
}
if (!$test) {
	echo "<span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
echo " ".$strings['pass'];
echo "<br>- ".$strings['testOtherfiles']." : ";
include("./Dwld/dataSQL.php");
$test = true;
foreach ($otherthings as $index=>$what) {
	$what = trim($what);
	if (!isset($$what)) {
		echo $what." ".$strings['missing'].", ";
		$test = false;
	} else {
		echo $what.", ";
	}
}
if (!$test) {
	echo "<span class=\"error\">".$strings['failed']."</span></div>";
	return;
}
echo " ".$strings['pass'];

// We passed all tests. Form to decide what to update
echo "\n<FORM action=\"index.php\" method=\"POST\">
<table class=\"form\" align=\"center\">
<tr><td><INPUT type=\"checkbox\" checked name=\"upgradeIP2C\" value=\"upgradeIP2C\"></td><td>".$strings['UpgradeIP2C']."</td></tr>
<tr><td><INPUT type=\"checkbox\" checked name=\"upgradeOS\" value=\"upgradeOS\"></td><td>".$strings['UpgradeOSList']."</td></tr>
<tr><td><INPUT type=\"checkbox\" checked name=\"upgradeWB\" value=\"upgradeWB\"></td><td>".$strings['UpgradeWBList']."</td></tr>
<tr><td><INPUT type=\"checkbox\" checked name=\"upgradeSE\" value=\"upgradeSE\"></td><td>".$strings['UpgradeSEList']."</td></tr>
<tr><td><INPUT type=\"checkbox\" checked name=\"insertIPBan\" value=\"insertIPBan\"></td><td>".$strings['InsertIPban']."</td></tr>
<tr><td><INPUT type=\"checkbox\" checked name=\"deltemp\" value=\"deltemp\"></td><td>".$strings['DelTmpUpdate']."</td></tr>
<tr><td colspan=\"2\" align=\"center\"><INPUT type=\"submit\" value=".$strings['Ok']."></td></tr>
</table>
<input type=\"hidden\" name=\"mode\" value=\"update\"><input type=\"hidden\" name=\"todo\" value=\"performupdate\"><input type=\"hidden\" name=\"ipclist\" value=\"".$infoupdate[2]."\"><input type=\"hidden\" name=\"otherlist\" value=\"".$infoupdate[3]."\"><input type=\"hidden\" name=\"version\" value=\"$version\">
</FORM>";
echo "\n</div>\n";
}

/*********************************************************************************
/* Function: doUpdate
/* Role: perform update after download, according to the form filled by the user
/* Parameters:
/*   - $c: connection to the database
/* Output:
/* Created 04/2008 /********************************************************************************/
function doUpdate($c) {
global $config_table;
global $strings;

if (! is_file("./Dwld/dataSQL.php")) {
	echo "<div class=\"error\">./Dwld/dataSQL.php ".$strings['missing'].".</div>";
} else {
	include("./Dwld/dataSQL.php");
}
$other = explode("|",trim($_POST['otherlist']));
echo "<div id=\"text\">\n";

// OS list
if (isset($_POST['upgradeOS']) && in_array('os_list',$other)) {
	echo "<P><b>".$strings['doUpgradeOSList']."</b>";
	if (!isset($os_list)) {
		echo "<br>- <span class=\"error\">".$strings['failed']."</span>: os_list ".$strings['missing'];
	} else {
		$sql = "UPDATE `$config_table` SET value='$os_list' WHERE variable LIKE 'os_list'";
		if (!mysql_query($sql,$c)) {
			echo "<br>- <span class=\"error\">".$strings['Errorwithdatabase']."</span> : <blockquote>".mysql_error()."<br>$sql</blockquote>";
		} else {
			echo "<br>- ".$strings['Done'];
		}
	}
	echo "</P>\n";
}

// Browser list
if (isset($_POST['upgradeWB']) && in_array('browser_list',$other)) {
	echo "<P><b>".$strings['doUpgradeWBList']."</b>";
	if (!isset($browser_list)) {
		echo "<br>- <span class=\"error\">".$strings['failed']."</span>: browser_list ".$strings['missing'];
	} else {
		$sql = "UPDATE `$config_table` SET value='$browser_list' WHERE variable LIKE 'browser_list'";
		if (!mysql_query($sql,$c)) {
			echo "<br>- <span class=\"error\">".$strings['Errorwithdatabase']."</span> : <blockquote>".mysql_error()."<br>$sql</blockquote>";
		} else {
			echo "<br>- ".$strings['Done'];
		}
	}
	echo "</P>\n";
}

// Search engine list
if (isset($_POST['upgradeSE']) && in_array('search_engines',$other)) {
	echo "<P><b>".$strings['doUpgradeSEList']."</b>";
	if (!isset($search_engines)) {
		echo "<br>- <span class=\"error\">".$strings['failed']."</span>: search_engines ".$strings['missing'];
	} else {
		$sql = "UPDATE `$config_table` SET value='$search_engines' WHERE variable LIKE 'search_engines'";
		if (!mysql_query($sql,$c)) {
			echo "<br>- <span class=\"error\">".$strings['Errorwithdatabase']."</span> : <blockquote>".mysql_error()."<br>$sql</blockquote>";
		} else {
			echo "<br>- ".$strings['Done'];
		}
	}
	echo "</P>\n";
}

// Inserting new IP Ban
if (isset($_POST['insertIPBan']) && in_array('ipbanlist',$other)) {
	echo "<P><b>".$strings['doInsertIPban']."</b>";
	if (!isset($ipbanlist)) {
		echo "<br>- <span class=\"error\">".$strings['failed']."</span>: ipbanlist ".$strings['missing'];
	} else {
		foreach($ipbanlist as $id=>$iprange) {
			$start = $iprange[0];
			$range = $iprange[1];
			$ipstart = long2ip($start);
			$ipend = long2ip($start+$range);
			$sql = "SELECT count(*) as count FROM ${config_table}_ipban WHERE ((ip=$start) AND (range=$range))";
			$res = mysql_query($sql,$c);
			$row = mysql_fetch_object($res);
			if (($row->count == 0) or ($row->count == '')) {
				echo "<br>- ".$strings['insertIPRange'].": $ipstart - $ipend";
				$time = date("Y-m-d");
				$sql = "INSERT INTO `${config_table}_ipban` VALUES('', '$start', '$range', '$time', '$time', '')";
				if (!mysql_query($sql,$c)) {
					echo "<br>- <span class=\"error\">".$strings['Errorwithdatabase']."</span> : <blockquote>".mysql_error()."<br>$sql</blockquote>";
				}
			}
		}
		echo "<br>- ".$strings['Done'];
		echo "</P>\n";
	}
}

// IP to country database
if (isset($_POST['upgradeIP2C'])) {
	echo "<P><b>".$strings['doUpgradeIP2C']."</b>";
	$ip2cList = explode("|",trim($_POST['ipclist']));
	foreach ($ip2cList as $index=>$file) {
		$file = trim($file);
		$newfile = str_replace("Dwld","Ip2c",$file);
		if ((!is_file($file) || (!is_readable($file)))) {
			echo "<br>- <span class=\"error\">".$strings['failed']."</span>: ".$file." ".$strings['missing'].",";
		} else {
			if (!rename($file,$newfile)) {
				echo "<br>- <span class=\"error\">".$strings['failed']."</span>: $file - $newfile,";
			}
		}
	}
	echo "<br>- ".$strings['Done'];
	echo "</P>\n";
}

// Delete temporary files
if(isset($_POST['deltemp'])) {
	echo "<P><b>".$strings['doDelTmpUpdate']."</b>";
	$ls = ls("Dwld/");
	foreach($ls as $index=>$file) {
		if (($file != "." && $file != "..")) {
			unlink("Dwld/".$file);
		}
	}
	unlink("./tmp/update.tgz");
	echo "<br>- ".$strings['Done'];
	echo "</P>\n";
}

// Conclusion
$version = $_POST['version'];
$sql = "UPDATE `$config_table` SET value='$version' WHERE variable LIKE 'currentupdate'";
if (!mysql_query($sql,$c)) {
	echo "<br>- <span class=\"error\">".$strings['Errorwithdatabase']."</span> : <blockquote>".mysql_error()."<br>$sql</blockquote>";
}
echo "<center>".$strings['donewithupdate'].".<br>".$strings['updateversionwas']." $version.</center>";
echo "</div>\n";
}

/*********************************************************************************
/* Function: updatePage
/* Role: main page for updates, offer options to registered, info on last update...
/* Parameters:
/*   - $c: connection to the database
/* Output:
/* Created 04/2008 /********************************************************************************/
function updatePage($c) {
global $registration;
global $strings;
global $config_table;
global $lang;


echo "<div id=\"text\">\n";
if ($registration['registered'] == '1') {
	echo "<table class=\"basic\"><tr><td>\n";
	echo "<P>".$strings['Unregistered']."</P>\n";
	echo "<P>".$strings['WhyRegister']."</P>\n";
	echo "<P>".$strings['WhyRegister2']."</P>\n";
	echo "<P>".$strings['TestUpdateService'].": <blockquote><a href=\"http://soft.zoneo.net/Utils/index.php?mode=update&amp;todo=test&amp;lang=$lang\">".$strings['StartUpdateTest']."</a></blockquote></P>\n";
	echo "<P>".$strings['IfUpdateTest']."<blockquote><a href=\"http://www.phpTrafficA.com/register.php\">Register today!</a></blockquote></P>";
	echo "</td><td>\n";
	echo "<table class=\"form\" align=\"center\" width=\"40%\"><tr><td colspan=\"2\">".$strings['Didregister']."</td></tr>
<tr><td>".$strings['UserID']."</td><td><input type=\"text\" name=\"userID\" maxlength=\"50\" value=\"\" size=\"20\"><td></tr>
<tr><td>".$strings['Password']."</td><td><input type=\"password\" name=\"passwd\" maxlength=\"50\" size=\"20\"></td></tr>
<tr><td>".$strings['RepeatPassword']."</td><td><input type=\"password\" name=\"passwd2\" maxlength=\"50\" size=\"20\"></td></tr>
</table>
</td></tr></table>\n";
	
} else {
	if ($lookforupdate) {
		$today = strtotime(date("Y-m-d"));
		if ($registration['lastchecked'] == "") {
			$lastchecked = 0;
		} else {
			$lastchecked = strtotime($registration['lastchecked']);
		}
		//if ($today > $lastchecked) {
			$test = file("http://data.phpTrafficA.com/last.php");
			$line = explode("|", $test[0]);
			$last = $line[0];
			if($last >  $registration['currentupdate']) {
				echo "<div class=\"announce\">".$strings['UpdateAvailable']."<br><a href=\"./index.php?mode=update&lang=$lang&version=$last\">".$strings['InstallUpdate']."</a></div>\n";
			}
			if (trim($registration['registrationexpires'])=="") {
				$end = time();
			} else {
				$end = strtotime($registration['registrationexpires']);
			}
			$remaining = intval((time()-$end)/8400);
			if ($remaining < 30) {
				echo "<div class=\"announce\">".$strings['regRemaining'].": $remaining<br><a href=\"http://www.phpTrafficA.com/register.php\">Renew today!</a></div>";
			}
			$sql = "UPDATE $config_table SET value='".date("Y-m-d")."' WHERE variable LIKE 'lastchecked'";
			$result = mysql_query ($sql,$c);
		//}
	}
	return 1;
}
echo "</div>\n";
}

/*********************************************************************************
/* Function: update
/* Role: update interface, calls the various procedures
/* Parameters:
/*   - $c: connection to the database
/* Output:
/* Created 04/2008 /********************************************************************************/
function update($c) {
global $DEMO;
global $strings;

if (isset($_POST['todo'])) {
	if ($_POST['todo'] == "performupdate") {
		if ($DEMO) {
			echo "<div class=\"error\">".$strings['notindemo']."</div>\n";
		} else {
			$todo = "doupdate";
		}
	}
} else if (isset($_GET['todo'])) {
	if ($_GET['todo'] == "testupdate") {
		$todo = "testupdate";
	} else if ($_GET['todo'] == "test") {
		$todo = "testservice";
	}
}

switch($todo) {
	case "testupdate":
		testUpdate($c, $_GET['version']);
		break;
	case "doupdate":
		doUpdate($c);
		break;
	case "testservice":
		testService($c);
		break;
	default:
		updatepage($c);
		break;
}
}

?>